function dist = distance(theta_r,theta_s,distanceMetric)
% takes as input two distributions returns their distance
% if theta_r is a CxK matrix, we have C times a vector of the same length as theta_s
% see slmetric_pw for other possible parameters
% Author: Richard Socher

if size(theta_r) == size(theta_s)
    dist = slmetric_pw(theta_r,theta_s,distanceMetric);
else
    dist = zeros(size(theta_r,1) ,1);
    for c = 1:size(theta_r,1)
        dist(c) = slmetric_pw(theta_r(c,:)',theta_s,distanceMetric);
    end
end

