function subjectParameters = sampleSubjectParameters(HyperParam)
% samples particle parameters from priors
% needs lightspeed and fastfit libraries
% Author: Richard Socher

%prm = struct('eta1',0.8,'eta2',0.55,'eta3',0.05,'sigma',1e-05,'eps1',1.7, ...
%     'lambda',0.2,'poisson_lambda',5,'gamma',0);

subjectParameters.eta_s1 = randbeta(HyperParam.eta_s_beta(1),HyperParam.eta_s_beta(2));

subjectParameters.eta_r = dirichlet_sample(HyperParam.eta_r_dirichlet);

subjectParameters.sigma = randgamma(HyperParam.sigma_gamma_k);

subjectParameters.eps1 = randgamma(HyperParam.eps_gamma_k);

subjectParameters.lambda =  randbeta(HyperParam.lambda_beta(1),HyperParam.lambda_beta(2));
